
// Written by Aleksandar Maćašev as a part of the Chromapost project. www.chromapost.com
// Do not copy the code without permission. Contact me at macasev@gmail.com. I'm more than willing to grant permission.






import arb.soundcipher.*;
SCScore score;

PFont font;

Table table;
int n=-1;
int numcol = 2939; // number of colors
int colseq = 40; // number of colors in a sequence
int colseq3 = colseq*3;
float sq = 10; // square size in the main menu
float barx= 25; // selected sequence bar width
float bary= 150; // selected sequence bar height
float mar=2*barx; // margin



color[] c = new color[numcol]; //array of all colors
color[] sc = new color[colseq]; // selected sequence of colors



String[] days = new String[numcol];
String[] months = new String[numcol];
String[] monthsu = new String[numcol];
String[] years = new String[numcol];

String done; // date of the color
String donel, doner; // left and right dates



color white=color(255);
color starttest;





// grid from a single loop for the main menu. all colors to choose from
float y, x;
float u=10; //step by x
float v= 10; // step by y
float w=10; //unit width
float h=10; //unit height
int s=100; // cells in a row
int r=29; // number of rows 


int mou; // color array number based on mouse position
float xrect, yrect; // position of marker square for the start of the sequence



// music
float[] pitches = new float [(colseq*3)+1]; // adding extra dummy note for reseting the moving sqaure
float[] dyn = new float [(colseq*3)+1];
float[] dur =new float [(colseq*3)+1];
float[] art = new float [(colseq*3)+1];
float[] pan =new float [(colseq*3)+1];

float re, gr, bl;


float [] pitches1a = new float [colseq];
float [] pitches2a = new float [colseq];
float [] pitches3a = new float [colseq];


float [] pitches1 = new float [colseq];
float [] pitches2 = new float [colseq];
float [] pitches3 = new float [colseq];


float low=21; //lowest pitch
float high=108; //highest pitch

// PIANO ROLL

int keys=int(high-low)+1; // total numaber of pitches/keys
float keysd=2; // width of the field in piano roll
color keyline = color(50); // color of lines
color keyf = color(120); // color of keys
color keyff= color(255); // color of moving keys
float keyw=8.3333333333333; // key width 1000/120


float xx; // main marker square x value
float xxx; // jumping square x value
float yyy; // jumping square y value

// controling pixel for when the score is playing
color contp = #000001;
float contpx; 
float contpy=400-mar;
color contpp;
color black=color(0);

//images
PImage footer;
PImage play;


  int count;
  
  
  // dirty control
  color controol;
  int playing=1;
  int notplaying=0;
  int state;


void setup(){
  size(1100, 887);
  background(0);
  
  font = loadFont("GothamRounded-Book-12.vlw");
  
  
  
  
  xx=-barx;
  xxx=-keyw;
  yyy=-mar-mar;

  xrect=-100;
  yrect=-100;
  
  contpx=-100;
  
  
  
  table = loadTable("8years-plus17days.csv", "header");
  
  
  for (TableRow row : table.rows()) {
  String col = row.getString("color");
  String colo = "ff" + col ;
  n++;
  c[n] = unhex(colo);
  
  days[n]= row.getString("day");
  months[n]= row.getString("month");
  monthsu[n]=months[n].toUpperCase();
  years[n]= row.getString("year");
  
  
  
  
  }
  noStroke();

  for(int x=0; x<colseq; x++){
    sc[x] = color(255);

  }
  
footer= loadImage("footer.png");
play= loadImage("play.png");
 
image(footer, 0, height-mar);
count=0;



donel= " "; // left date blank
doner= " "; //right date blank
  
}





void draw(){
  
  
  
  
  
  
  // cursors
  
   starttest=get(65, 500);
  
    //main color menu
    if((mouseY>=mar && mouseY<=(r*h)+mar)&&(mouseX>=mar && mouseX<=width-mar) && contpp==black ){
    cursor(CROSS);
    }
    // play button
    else if((mouseY>=380 && mouseY<=410)&&(mouseX>=(width/2)-15 && mouseX<=(width/2)+15) && (starttest!=white && contpp==black )){
     cursor(HAND); 
      
    }
    else
{
  cursor(ARROW);
}
  
  
  
  
  
  
  
  
   //main color menu
  
  pushMatrix();
  translate(mar, mar);
  for(int i=0; i<(s*r); i++){
    noStroke();
    
    
     x=i*u; 
     
     
     //makes a jump for each row
     for(int j=0; j<r+1; j++){

    if(i>=(j*s) && i<((j+1)*s)){
      y=j*v;
      x=x-(u*(j*s));
}
     }


  
    fill(c[i]);

    rect(x, y, w, h);

  } 
    
  
  
  
  
 // selected sequence 
  
for(int x=0; x<colseq; x++){
  stroke(0);
  strokeWeight(1);
  fill(sc[x]);

  rect(x*barx, 400, barx, bary);

}

// selected color square
 noFill();
  stroke(255);
  strokeWeight(1);
  
  rect(xrect, yrect, 9, 9); 
   



//redraw for marker square
noStroke();
fill(0);
rect(0, 374, width-(2*mar), barx);


 //marker square
stroke(0);
  fill(255);
  rect(xx, 394, barx, 5);


//masks for the marker square

  fill(0);
  rect(-mar, 374, mar, mar);
  
  
  noStroke();
  fill(0);
  rect(width-mar-mar, 374, mar, mar);
 
  //mask for controlling pixel
  fill(0);
  stroke(0);
  rect(40-mar, 387-mar, 25, 25);
  

  
 // controlling pixel
  fill(contp);
  noStroke();
  rect(contpx, contpy, 5, 5);
  contpp=get(50, 400); 
  
  
  
  
  // PIANO ROLL

  
  
  

// jumping square
noStroke();
  fill(255);
  rect(xxx, yyy, barx/3, keysd);

// mask for jumping square

  fill(0);
  rect(-mar, 610-mar, mar, keys*keysd);


  
  //lines
  
  for(int x=0; x<keys+1; x++){
      
    stroke(keyline);
      line(0, (x*keysd)+610-mar, width-(2*mar), (x*keysd)+610-mar);
      
      
    }


// dates
noStroke();
fill(255);
textFont(font);
textSize(12);
textAlign(LEFT);
//donel=days[0+shift]+" "+monthsu[0+shift]+" "+years[0+shift];

text(donel, 0, 434-mar);

textAlign(RIGHT);

text(doner, colseq*barx, 434-mar);



 popMatrix(); 
  
}



void mousePressed(){
  
  // main color menu
  if((mouseY>=mar && mouseY<=(r*h)+mar)&&(mouseX>=mar && mouseX<=width-mar) && contpp==black ){
    
   
    
    image(play, (width/2)-15, 380);
    
    
    
    
  score = new SCScore(); // START A NEW SCORE EVERY TIME MOUSE IS CLICKED
  score.tempo(600); // score tempo
  score.addCallbackListener(this);  //listener to callbacks
  
  

  
  mou=floor(((mouseX-mar)/sq))+(floor((mouseY-mar)/sq)*s);
  
  donel= days[mou]+" "+monthsu[mou]+" "+years[mou]; // left date
  doner= days[mou+colseq-1]+" "+monthsu[mou+colseq-1]+" "+years[mou+colseq-1]; //right date
  
  for(int x=0; x<colseq; x++){
    sc[x] = c[x+mou];
    
    
    
    
    
    

  }
  
  
  
  xrect=(mouseX-(mouseX%10))-mar;
  yrect=(mouseY-(mouseY%10))-mar;
  
  
  
  
  
  // music elements
  
  for(int x=0; x<colseq; x++){
    re = red(sc[x]);
    pitches1a[x] = map(re, 0, 255, low, high);
    gr = green(sc[x]);
    pitches2a[x] = map(gr, 0, 255, low, high);
    bl = blue(sc[x]);
    pitches3a[x] = map(bl, 0, 255, low, high);
    

  }
  
  
   for(int x=0; x<colseq; x++){
   
    pitches1[x] = float(round(pitches1a[x]));
    
    pitches2[x] = float(round(pitches2a[x]));
  
    pitches3[x] = float(round(pitches3a[x]));
    

  }
  
  
  
  
 // adding 3 arrays into the main one
  for(int x=0; x<colseq; x++){
  
  pitches[3*x] = pitches1[x];
  pitches[(3*x)+1] = pitches2[x];
  pitches[(3*x)+2] = pitches3[x];
  

  }
  
  //adding extra dummy pitch
  pitches[colseq*3]=0;
  
  
  for(int x=0; x<colseq*3; x++){
  
  dyn[x] = 100;
  dur[x] = 1;
  art[x] = 1;
  pan[x] = x*(127/(colseq*3));
  }
  
  //adding extra dummy rest
  dyn[colseq*3]=0;
  dur[colseq*3]=1;
  art[colseq*3]=1;
  pan[colseq*3]=0;
 
  score.addPhrase(1, 0, 0,  pitches, dyn, dur, art, pan);
  
  
     //adding callback events for every third beat
     
     int id;
  for(int i=0; i<colseq3+1; i++) {
      
      if(i%3==0 && i!=colseq3){
        id=1;} // id for moving the square
      else  if(i==colseq3){
          id=2;} // id for dummy tone
        else
        {
          id=3;
        }
      
    score.addCallback(i+1, id);
  }

 // keys on piano roll based on pitch value
 
 
   //redraw for piano roll
  noStroke();
  fill(0);
  rect(0, 610, width, 88*keysd);
 
 
 for(int x=0; x<colseq3; x++){
 
 noStroke();
 fill(keyf);
 rect((x*keyw)+mar, ((high-pitches[x])*keysd)+610, keyw, keysd);
 
 
 
 }
 
 
 }
 
 // play button

 
 if((mouseY>=380 && mouseY<=410) && (mouseX>=(width/2)-15 && mouseX<=(width/2)+15) && (starttest!=white && contpp==black )){
     xx=-25;

  score.play();
 
 }
 
}


void keyPressed(){
  if(key=='s' || key=='S'){

  score.stop();
 
  }
  if(key=='p' || key=='P'){
    String p = "screengrab" + ".png";
  saveFrame(p);
}
  
  
  
}

// controlling callback events

void handleCallbacks(int callbackID) {
  int idd=1;
  int iddd=2;
  int idddd=3;
  int step=25;
  

  
  
  if(callbackID == 1) {
    xx=xx+step;
    contpx=0;
    //redraw();
  }
  
  if(callbackID == 2) {
    xx=-step;
    count=0;
    xxx=-keyw;
    contpx=-100;


  }
  
  if(callbackID == 1 || callbackID == 3){
    
    xxx=xxx+keyw;
    yyy=((high-pitches[count])*keysd)+610-mar;
    
    count=count+1;
    
  }
  
  
}
 
  
  
  
  
  
  
  